/*
 * puzzle.h
 *
 *
 * declarations for puzzle.c
 *
 * by Korbinian Strimmer and Arndt von Haeseler
 *
 */


/* load all necessary libraries */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <time.h>


/* all EXTERNal variables are local in puzzle.c */

#ifdef MAIN_MODULE
#define EXTERN
#else
#define EXTERN extern
#endif


/* global definitions */

#define TRUE 1
#define FALSE 0
#define boolean int

#define VERSION    "2.0"
#define DATE       "23 July 1995"


/* declarations of modules */

#include "qml.h"
#include "matrixut.h"
#include "treefuncs.h"
#include "quartet.h"
#include "random.h"


/*
 * puzzle.c
 */


/* pointer to files */
EXTERN FILE *treefp; /* treefile */

/* variables */
EXTERN int Info_optn;
EXTERN int Approx_optn;
EXTERN int first_optn;
EXTERN int Numtrial;  /* number of trials for one data set */
/* remark: because of the randomization of the input order
   each trial may give another tree if the data is not perfect */
EXTERN int Currtrial;
EXTERN int Maxbrnch;
EXTERN ivector trueID; /* gives the true Identifs -> randomize input order */
EXTERN ivector freeID;
