/*
 * treefuncs.h
 *
 * declarations for treefuncs.c
 *
 * by Korbinian Strimmer and Arndt von Haeseler (1995)
 *
 */


/* type definitions */

typedef struct oneedge {
	/* pointer to other three edges */
	struct oneedge *up;
	struct oneedge *downleft;
	struct oneedge *downright;
	
	/* number of edge */
	int numedge;
	
	/* info about edge - in puzzle a double */
	double edgeinfo;
	
	/* pointer to the local edgemap (= integer vector) */
	int *edgemap;
} ONEEDGE;


/* variables */

EXTERN ONEEDGE *edge; /* vector with all the edges of the tree */
EXTERN int *edgeofleaf; /* vector with edge number of all leaves */

EXTERN int nextedge; /* number of edges in the current tree */
EXTERN int nextleaf; /* next leaf to add to tree */
/* = number of leaves in the current tree (leaves/edges are counted from 0) */

EXTERN int minedge; /* edge with minimum edgeinfo */
EXTERN double mininfo; /* value of edgeinfo on that edge */

EXTERN int column; /* for breaking lines in writing tree to treefile */


/* prototypes */

void inittree();
void addnextleaf(int dockedge);
void freetree();
void showpath(int A, int B);
void showallconnections();
void resetedgeinfo();
void incrementedgeinfo(int A, int B, double w);
void writetree(FILE *outfp);
void minimumedgeinfo();
